<html>
<head>
<title>OGRE: Ogre::WindowEventUtilities Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1WindowEventUtilities.html">WindowEventUtilities</a></div>
<h1>Ogre::WindowEventUtilities Class Reference</h1><!-- doxytag: class="Ogre::WindowEventUtilities" -->Utility class to handle Window Events/Pumping/Messages  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1WindowEventUtilities-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
std::multimap<br>
&lt; <a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *,<br>
 <a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#3c682bc1eab7000d403564b318bae1f9">WindowEventListeners</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#84c5b63174d4519d9fb0b550e992725b">Windows</a></td></tr>

<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#2b01f340e3022446fa9e7a0addeb6610">messagePump</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Call this once per frame if not using <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>:startRendering().  <a href="#2b01f340e3022446fa9e7a0addeb6610"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#23cdc6e59dbbb5415d921df8a2b8631b">addWindowEventListener</a> (<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *window, <a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a> *listener)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a listener to listen to renderwindow events (multiple listener's per renderwindow is fine) The same listener can listen to multiple windows, as the Window Pointer is sent along with any messages.  <a href="#23cdc6e59dbbb5415d921df8a2b8631b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#d43ba51bd926251f959a23d6883de815">removeWindowEventListener</a> (<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *window, <a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a> *listener)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove previously added listener  <a href="#d43ba51bd926251f959a23d6883de815"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#b208c9879ca60777fcb5e84c05be2b3a">_addRenderWindow</a> (<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *window)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Called by RenderWindows upon creation for <a class="el" href="namespaceOgre.html">Ogre</a> generated windows.  <a href="#b208c9879ca60777fcb5e84c05be2b3a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#d33fda52ffa451f45f2f9f08a2970bd5">_removeRenderWindow</a> (<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *window)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Called by RenderWindows upon creation for <a class="el" href="namespaceOgre.html">Ogre</a> generated windows.  <a href="#d33fda52ffa451f45f2f9f08a2970bd5"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1WindowEventUtilities.html#3c682bc1eab7000d403564b318bae1f9">WindowEventListeners</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#482ccdb9b1bbdc5439c622399ff4b0b9">_msListeners</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1WindowEventUtilities.html#84c5b63174d4519d9fb0b550e992725b">Windows</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WindowEventUtilities.html#930c740afae53b8336150b4b9794c96f">_msWindows</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Utility class to handle Window Events/Pumping/Messages 
<p>Definition at line <a class="el" href="OgreWindowEventUtilities_8h-source.html#l00090">90</a> of file <a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="3c682bc1eab7000d403564b318bae1f9"></a><!-- doxytag: member="Ogre::WindowEventUtilities::WindowEventListeners" ref="3c682bc1eab7000d403564b318bae1f9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::multimap&lt;<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a>*, <a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a>*&gt; <a class="el" href="classOgre_1_1WindowEventUtilities.html#3c682bc1eab7000d403564b318bae1f9">Ogre::WindowEventUtilities::WindowEventListeners</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreWindowEventUtilities_8h-source.html#l00149">149</a> of file <a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="84c5b63174d4519d9fb0b550e992725b"></a><!-- doxytag: member="Ogre::WindowEventUtilities::Windows" ref="84c5b63174d4519d9fb0b550e992725b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a>*&gt; <a class="el" href="classOgre_1_1WindowEventUtilities.html#84c5b63174d4519d9fb0b550e992725b">Ogre::WindowEventUtilities::Windows</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreWindowEventUtilities_8h-source.html#l00152">152</a> of file <a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="2b01f340e3022446fa9e7a0addeb6610"></a><!-- doxytag: member="Ogre::WindowEventUtilities::messagePump" ref="2b01f340e3022446fa9e7a0addeb6610" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::WindowEventUtilities::messagePump           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Call this once per frame if not using <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>:startRendering(). 
<p>
This will update all registered RenderWindows (If using external Windows, you can optionally register those yourself) 
</div>
</div><p>
<a class="anchor" name="23cdc6e59dbbb5415d921df8a2b8631b"></a><!-- doxytag: member="Ogre::WindowEventUtilities::addWindowEventListener" ref="23cdc6e59dbbb5415d921df8a2b8631b" args="(RenderWindow *window, WindowEventListener *listener)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::WindowEventUtilities::addWindowEventListener           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *&nbsp;</td>
          <td class="paramname"> <em>window</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a listener to listen to renderwindow events (multiple listener's per renderwindow is fine) The same listener can listen to multiple windows, as the Window Pointer is sent along with any messages. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>window</em>&nbsp;</td><td>The <a class="el" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a> you are interested in monitoring </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>listner</em>&nbsp;</td><td>Your callback listener </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="d43ba51bd926251f959a23d6883de815"></a><!-- doxytag: member="Ogre::WindowEventUtilities::removeWindowEventListener" ref="d43ba51bd926251f959a23d6883de815" args="(RenderWindow *window, WindowEventListener *listener)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::WindowEventUtilities::removeWindowEventListener           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *&nbsp;</td>
          <td class="paramname"> <em>window</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove previously added listener 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>window</em>&nbsp;</td><td>The <a class="el" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a> you registered with </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>listner</em>&nbsp;</td><td>The listener registered </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="b208c9879ca60777fcb5e84c05be2b3a"></a><!-- doxytag: member="Ogre::WindowEventUtilities::_addRenderWindow" ref="b208c9879ca60777fcb5e84c05be2b3a" args="(RenderWindow *window)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::WindowEventUtilities::_addRenderWindow           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *&nbsp;</td>
          <td class="paramname"> <em>window</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Called by RenderWindows upon creation for <a class="el" href="namespaceOgre.html">Ogre</a> generated windows. 
<p>
You are free to add your external windows here too if needed. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>window</em>&nbsp;</td><td>The <a class="el" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a> to monitor </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="d33fda52ffa451f45f2f9f08a2970bd5"></a><!-- doxytag: member="Ogre::WindowEventUtilities::_removeRenderWindow" ref="d33fda52ffa451f45f2f9f08a2970bd5" args="(RenderWindow *window)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::WindowEventUtilities::_removeRenderWindow           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderWindow.html">RenderWindow</a> *&nbsp;</td>
          <td class="paramname"> <em>window</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Called by RenderWindows upon creation for <a class="el" href="namespaceOgre.html">Ogre</a> generated windows. 
<p>
You are free to add your external windows here too if needed. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>window</em>&nbsp;</td><td>The <a class="el" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a> to remove from list </td></tr>
  </table>
</dl>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="482ccdb9b1bbdc5439c622399ff4b0b9"></a><!-- doxytag: member="Ogre::WindowEventUtilities::_msListeners" ref="482ccdb9b1bbdc5439c622399ff4b0b9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WindowEventUtilities.html#3c682bc1eab7000d403564b318bae1f9">WindowEventListeners</a> <a class="el" href="classOgre_1_1WindowEventUtilities.html#482ccdb9b1bbdc5439c622399ff4b0b9">Ogre::WindowEventUtilities::_msListeners</a><code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreWindowEventUtilities_8h-source.html#l00150">150</a> of file <a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="930c740afae53b8336150b4b9794c96f"></a><!-- doxytag: member="Ogre::WindowEventUtilities::_msWindows" ref="930c740afae53b8336150b4b9794c96f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WindowEventUtilities.html#84c5b63174d4519d9fb0b550e992725b">Windows</a> <a class="el" href="classOgre_1_1WindowEventUtilities.html#930c740afae53b8336150b4b9794c96f">Ogre::WindowEventUtilities::_msWindows</a><code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreWindowEventUtilities_8h-source.html#l00153">153</a> of file <a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreWindowEventUtilities_8h-source.html">OgreWindowEventUtilities.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:55:13 2008
</p>
</body>
</html>
